Skip to content

Latest commit

 

History

History
 
 

2092

Folders and files

NameName
Last commit message
Last commit date

parent directory

..
 
 

You are given an integer n indicating there are n people numbered from 0 to n - 1. You are also given a 0-indexed 2D integer array meetings where meetings[i] = [xi, yi, timei] indicates that person xi and person yi have a meeting at timei. A person may attend multiple meetings at the same time. Finally, you are given an integer firstPerson.

Person 0 has a secret and initially shares the secret with a person firstPerson at time 0. This secret is then shared every time a meeting takes place with a person that has the secret. More formally, for every meeting, if a person xi has the secret at timei, then they will share the secret with person yi, and vice versa.

The secrets are shared instantaneously. That is, a person may receive the secret and share it with people in other meetings within the same time frame.

Return a list of all the people that have the secret after all the meetings have taken place. You may return the answer in any order.

 

Example 1:

Input: n = 6, meetings = [[1,2,5],[2,3,8],[1,5,10]], firstPerson = 1
Output: [0,1,2,3,5]
Explanation:
At time 0, person 0 shares the secret with person 1.
At time 5, person 1 shares the secret with person 2.
At time 8, person 2 shares the secret with person 3.
At time 10, person 1 shares the secret with person 5.​​​​
Thus, people 0, 1, 2, 3, and 5 know the secret after all the meetings.

Example 2:

Input: n = 4, meetings = [[3,1,3],[1,2,2],[0,3,3]], firstPerson = 3
Output: [0,1,3]
Explanation:
At time 0, person 0 shares the secret with person 3.
At time 2, neither person 1 nor person 2 know the secret.
At time 3, person 3 shares the secret with person 0 and person 1.
Thus, people 0, 1, and 3 know the secret after all the meetings.

Example 3:

Input: n = 5, meetings = [[3,4,2],[1,2,1],[2,3,1]], firstPerson = 1
Output: [0,1,2,3,4]
Explanation:
At time 0, person 0 shares the secret with person 1.
At time 1, person 1 shares the secret with person 2, and person 2 shares the secret with person 3.
Note that person 2 can share the secret at the same time as receiving it.
At time 2, person 3 shares the secret with person 4.
Thus, people 0, 1, 2, 3, and 4 know the secret after all the meetings.

Example 4:

Input: n = 6, meetings = [[0,2,1],[1,3,1],[4,5,1]], firstPerson = 1
Output: [0,1,2,3]
Explanation:
At time 0, person 0 shares the secret with person 1.
At time 1, person 0 shares the secret with person 2, and person 1 shares the secret with person 3.
Thus, people 0, 1, 2, and 3 know the secret after all the meetings.

 

Constraints:

  • 2 <= n <= 105
  • 1 <= meetings.length <= 105
  • meetings[i].length == 3
  • 0 <= xi, yi <= n - 1
  • xi != yi
  • 1 <= timei <= 105
  • 1 <= firstPerson <= n - 1

Similar Questions:

Solution 1. Union Find

Sort meetings in ascending order of meeting time.

Visit the meetings happening at the same time together.

We can connect the two persons in the same meeting using a UnionFind.

Tricky point here: After traversing this batch of meetings, we reset the persons who don't know the secret by checking if he/she is connected to person 0. With UnionFind, reseting means setting id[x] = x.

In the end, we add all the persons who are connected to person 0 into the answer array.

// OJ: https://leetcode.com/problems/find-all-people-with-secret/
// Author: github.com/lzl124631x
// Time: O(MlogM + (M + N) * logN) where `M` is the length of `meetings`
//        Can be reduced to `O(MlogM + (M + N) * alpha(N))`
// Space: O(M + N). Can be reduced to O(N) if we make `ppl` an `unordered_set`.
class UnionFind {
    vector<int> id;
public:
    UnionFind(int n) : id(n) {
        iota(begin(id), end(id), 0);
    }
    void connect(int a, int b) {
        id[find(b)] = find(a);
    }
    int find(int a) {
        return id[a] == a ? a : (id[a] = find(id[a]));
    }
    bool connected(int a, int b) {
        return find(a) == find(b);
    }
    void reset(int a) { id[a] = a; }
};
class Solution {
public:
    vector<int> findAllPeople(int n, vector<vector<int>>& A, int firstPerson) {
        sort(begin(A), end(A), [](auto &a, auto &b) { return a[2] < b[2]; }); // Sort the meetings in ascending order of meeting time
        UnionFind uf(n);
        uf.connect(0, firstPerson); // Connect person 0 with the first person
        vector<int> ppl;
        for (int i = 0, M = A.size(); i < M; ) {
            ppl.clear();
            int time = A[i][2];
            for (; i < M && A[i][2] == time; ++i) { // For all the meetings happening at the same time
                uf.connect(A[i][0], A[i][1]); // Connect the two persons
                ppl.push_back(A[i][0]); // Add both persons into the pool
                ppl.push_back(A[i][1]);
            }
            for (int n : ppl) { // For each person in the pool, check if he/she's connected with person 0.
                if (!uf.connected(0, n)) uf.reset(n); // If not, this person doesn't have secret, reset it.
            }
        }
        vector<int> ans;
        for (int i = 0; i < n; ++i) {
            if (uf.connected(0, i)) ans.push_back(i); // Push all the persons who are connected with person 0 into answer array
        }
        return ans;
    }
};

Complexity Analysis:

Sorting takes O(MlogM) time.

Each meeting is visited and pushed into/popped out of ppl only once. For each visit, the connect/connected takes amortized O(logN) time. So, traversing all the meetings takes O(MlogN) time. Note that if we do union-by-rank, the time complexity can be reduced to O(M * alpha(N)) where alpha(N) is the inverse function of Ackermann function, and is even more efficient than logN. But in LeetCode, the difference is negligible, so I usually just use path compression for simplicity. It's definitly worth mentioning this knowledge during your interview though.

Lastly, traversing all the persons and checking connection with person 0 takes amortized O(NlogN) time.

So, overall the time complexity is amortized O(MlogM + (M + N) * logN), which can be reduced to O(MlogM + (M + N) * alpha(N)) with union-by-rank.

As for space complexity, the Union Find takes O(N) space. The ppl array takes O(M) space in the worst case, but it can be reduced to O(N) if we use unordered_set. I use vector<int> because unordered_set<int> has extra overhead which at times consumes more time/space than vector<int> in LeetCode.

So, overall the (extra) space complexity is O(M + N) which can be reduced to O(N).

Discuss

https://leetcode.com/problems/find-all-people-with-secret/discuss/1599815/C%2B%2B-Union-Find